﻿using System;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using OpcLabs.EasyOpc.DataAccess.LiveMapping;
using OpcLabs.EasyOpcLiveTest.Legacy.Environment.OpcKitServer;
using OpcLabs.UnitTestLib;

namespace OpcLabs.EasyOpcLiveTest.Legacy.LiveMapping._Testers
{
    class MetaMemberTester
    {
        //            [DAType, DASubscription(RequestedUpdateRate = 100)]
        //            private class MetaMemberTestType
        //            {
        //#pragma warning disable 67
        //                [DANode(ItemId = TestDefs.DataAccess.ItemIds.Incrementing_1s), DAItem(ItemType = typeof(int))]
        //                static public event DataEventHandler<int, StaticEventTestType> IncrementingEvent;
        //#pragma warning restore 67
        //            }

        [DASubscription(RequestedUpdateRate = 100)]
        private class MyRootNode1 : RootNode
        {
            public MyRootNode1()
            {
                Simulation = new MySimulationNode1();
            }
        }

        private class MySimulationNode1 : SimulationNode
        {
            public override int IncrementingValue
            {
                set
                {
                    Assert.IsNotNull(ServerDescriptor);
                    Assert.IsNotNull(NodeDescriptor);
                    Assert.IsNotNull(GroupParameters);
                    // ReSharper disable LocalizableElement
                    Console.WriteLine("value {0} coming from server {1}, branch {2}, update rate {3}", value,
                        ServerDescriptor.ServerClass, NodeDescriptor.BrowsePath, GroupParameters.RequestedUpdateRate);
                    // ReSharper restore LocalizableElement
                }
            }
        }

        public void Test()
        {
            var clientMapper = new DAClientMapper();
            var testTarget = new MyRootNode1();

            clientMapper.Map(testTarget, new DAMappingContext { ServerDescriptor = LegacyTestDefs.ProgIds.KitServer });

            clientMapper.Subscribe(true);
            //mapper.Subscribe(mapper.Mappings.Where(mapping => mapping.BelongsTo(testTarget)));
            AssertUtilities.WaitingPhase(10 * 1000);
            clientMapper.Subscribe(false);
        }
    }
}
