﻿using System.Linq;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using OpcLabs.EasyOpc;
using OpcLabs.EasyOpc.Implementation.Native.DataAccess;
using OpcLabs.EasyOpcLiveTest.Legacy.DataAccess;

namespace OpcLabs.EasyOpcLiveTest.Legacy.Native.DataAccess
{
    //[TestClass]
    public class NativeEasyDAClientTest
    {
        [TestClass]
        // ReSharper disable once InconsistentNaming
        public class NativeEasyDAClientCatalogTest_IEasyDAClient_Functional : IEasyDAClientCatalogTest_Functional
        {
            public NativeEasyDAClientCatalogTest_IEasyDAClient_Functional()
                : base(
                    () => new NativeEasyDAClient(),
                    new DAServerCatalog(DAServerCatalogEntries.Real.Where(entry => 
                        // ReSharper disable PossibleNullReferenceException
                        entry.Element.Technology == OpcTechnologies.Com)))
                        // ReSharper restore PossibleNullReferenceException
            {
            }
        }

        [TestClass]
        // ReSharper disable once InconsistentNaming
        public class NativeEasyDAClientTest_IEasyDAClient_BrowseNodes : IEasyDAClientTest_BrowseNodes
        {
            public NativeEasyDAClientTest_IEasyDAClient_BrowseNodes()
                : base(() => new NativeEasyDAClient())
            {
            }
        }

        [TestClass]
        // ReSharper disable once InconsistentNaming
        public class NativeEasyDAClientTest_IEasyDAClient_BrowseServers : IEasyDAClientTest_BrowseServers
        {
            public NativeEasyDAClientTest_IEasyDAClient_BrowseServers()
                : base(() => new NativeEasyDAClient())
            {
            }
        }

        [TestClass]
        // ReSharper disable once InconsistentNaming
        public class NativeEasyDAClientTest_IEasyDAClient_Com : IEasyDAClientTest_Com
        {
            public NativeEasyDAClientTest_IEasyDAClient_Com()
                : base(() => new NativeEasyDAClient())
            {
            }
        }

        [TestClass]
        // ReSharper disable once InconsistentNaming
        public class NativeEasyDAClientTest_IEasyDAClient_Com_BrowseAccessPaths : IEasyDAClientTest_Com_BrowseAccessPaths
        {
            public NativeEasyDAClientTest_IEasyDAClient_Com_BrowseAccessPaths()
                : base(() => new NativeEasyDAClient())
            {
            }
        }

        [TestClass]
        // ReSharper disable once InconsistentNaming
        public class NativeEasyDAClientTest_IEasyDAClient_Com_BrowsePath : IEasyDAClientTest_Com_BrowsePath
        {
            public NativeEasyDAClientTest_IEasyDAClient_Com_BrowsePath()
                : base(() => new NativeEasyDAClient())
            {
            }
        }

        [TestClass]
        // ReSharper disable once InconsistentNaming
        public class NativeEasyDAClientTest_IEasyDAClient_Intrinsic : IEasyDAClientTest_Intrinsic
        {
            public NativeEasyDAClientTest_IEasyDAClient_Intrinsic()
                : base(() => new NativeEasyDAClient())
            {
            }
        }
    }
}
