﻿using System;
using System.Diagnostics.CodeAnalysis;
using JetBrains.Annotations;
using OpcLabs.BaseLib.Diagnostics;
using OpcLabs.EasyOpc.UA.LiveMapping;

namespace OpcLabs.EasyOpcLiveTest.UA.Environment.UASampleServer
{
    // IMPROVE: isn't the DynamicNode same as StatiNode? (check the OPC SDK code). If so, implement as one class only.
    [CLSCompliant(false)]
#pragma warning disable 3021
    public class DynamicNode : UAMappedNode
#pragma warning restore 3021
    {
        [SuppressMessage("Microsoft.Usage", "CA2214:DoNotCallOverridableMethodsInConstructors")]    // caused by Code Contracts
        public DynamicNode()
        {
            UserScalar = new UserScalarNode();
        }

        [NotNull]
        [UANode]
        public UserScalarNode UserScalar { get; set; }  // non-nullness by invariant

        [UsedImplicitly]
        private void ObjectInvariant()
        {
            // Auto-implemented properties
            Check.Invariant(UserScalar != null);
        }
    }
}
