﻿using System;
using System.Collections.Generic;
using System.Threading;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using OpcLabs.EasyOpc.UA.AddressSpace;
using OpcLabs.EasyOpc.UA.PubSub;
using OpcLabs.EasyOpc.UA.PubSub.Configuration;
using OpcLabs.EasyOpc.UA.PubSub.OperationModel;
using OpcLabs.UnitTestLib;

namespace OpcLabs.EasyOpcLiveTest.UA.PubSub
{
    [TestClass]
    public class EasyUASubscriberTest
    {
        [TestMethod]
        public void DevelopmentTest()
        {
            //Debug.WriteLine("DEBUGTEST");
            //Trace.WriteLine("TRACETEST");
            //Console.WriteLine("CONSOLETEST");


            var subscriber = new EasyUASubscriber();
            subscriber.DataSetMessage += (sender, args) =>
            {
                AssertUtilities.WriteLine();
                AssertUtilities.WriteLine($"DataSetMessage args: {args}");
                if (args.Succeeded)
                    foreach (KeyValuePair<string, UADataSetFieldData> pair in args.DataSetData.FieldDataDictionary)
                        AssertUtilities.WriteLine(pair);
            };

            TestSection.Act();

            // TODO: subscriber.SubscribeDataSet("opc.udp://224.0.0.22");
            var dataSetMetaData = new UADataSetMetaData();
            dataSetMetaData.Fields.Add(new UAFieldMetaData("myField"));
            subscriber.SubscribeDataSet(new EasyUASubscribeDataSetArguments("opc.udp://224.0.0.22") {DataSetSubscriptionDescriptor = {DataSetMetaData = dataSetMetaData}});



            Thread.Sleep(5 * 60 * 1000);  // TODO:
        }

        [TestMethod]
        public void MessageChannel_Mqtt_Test()
        {
            var subscriber = new EasyUASubscriber();
            var dataSetSubscriptionDescriptor = new UADataSetSubscriptionDescriptor
            {
                CommunicationParameters = {BrokerDataSetReaderTransportParameters = {QueueName = "opcuademo/uadp/none"}},
                ConnectionDescriptor =
                {
                    CustomPropertyValueDictionary =
                    {
                        {new UAQualifiedName("http://opclabs.com/OpcUA/PubSub", "MessageChannel!"), "OpcLabs.Mqtt.MqttClientMessageChannel,OpcLabs.Mqtt"}
                    },
                    ResourceAddress = "mqtt://test.mosquitto.org"
                }
            };
            subscriber.SubscribeDataSet(dataSetSubscriptionDescriptor, (_, args) => Console.WriteLine(args));


            Thread.Sleep(20 * 1000);  // TODO:
        }
    }
}
