﻿
using JetBrains.Annotations;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using OpcLabs.EasyOpc.UA.AddressSpace;
using OpcLabs.EasyOpcFactory.UA.AddressSpace;
using OpcLabs.UnitTestLib;

namespace OpcLabs.EasyOpcTest.UA.AddressSpace
{
    public partial class UANodeElementCollectionTest
    {
        #region Test Methods

        [TestCategory("BinarySerialization")]
        [TestCategory("OpcUA")]
        [TestMethod]
        public void BinarySerializationTest0()
        {
            Tests.BinarySerializationTest(CreateSerializationTarget0());
        }

        [TestCategory("BinarySerialization")]
        [TestCategory("OpcUA")]
        [TestMethod]
        public void BinarySerializationTest1()
        {
            Tests.BinarySerializationTest(CreateSerializationTarget1());
        }

        [TestCategory("OpcUA")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        public void XmlSerializationTest0()
        {
            Tests.XmlSerializationTest(CreateSerializationTarget0());
        }

        [TestCategory("OpcUA")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        public void XmlSerializationTest1()
        {
            Tests.XmlSerializationTest(CreateSerializationTarget1());
        }

        #endregion



        #region Private Methods

        [NotNull]
        private UANodeElementCollection CreateSerializationTarget0()
        {
            return new UANodeElementCollection();
        }

        [NotNull]
        private UANodeElementCollection CreateSerializationTarget1()
        {
            var nodeElementCollection = new UANodeElementCollection
                                              {
                                                  UANodeElementInstances.Instance0,
                                                  UANodeElementInstances.Instance1
                                              };
            return nodeElementCollection;
        }

        #endregion
    }
}
