﻿
using JetBrains.Annotations;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using OpcLabs.BaseLib.DataTypeModel;
using OpcLabs.EasyOpc.UA.DataTypeModel;
using OpcLabs.EasyOpc.UA.DataTypeModel.Implementation;

namespace OpcLabs.EasyOpcTest.UA.DataTypeModel.Internal
{
    partial class DeveloperTest
    {
        #region Static Private Properties

        [NotNull]
        static private StructuredDataType IntegerArrayWithFixedLengthInBytesDataType => new StructuredDataType("IntegerArrayWithFixedLengthInBytes", "DeveloperTest:IntegerArrayWithFixedLengthInBytes")
        {
            new DataField("Array", new SequenceDataType(UAOpcBinaryStandardDataTypes.Int32))
        };

        [NotNull]
        static private StructuredData IntegerArrayWithFixedLengthInBytes_2Data => new StructuredData(IntegerArrayWithFixedLengthInBytesDataType)
        {
            {
                "Array", new SequenceData(new SequenceDataType(UAOpcBinaryStandardDataTypes.Int32))
                {
                    new PrimitiveData(UAOpcBinaryStandardDataTypes.Int32, 161),
                    new PrimitiveData(UAOpcBinaryStandardDataTypes.Int32, 162)
                }
            }
        };

        [NotNull]
        static private StructuredData IntegerArrayWithFixedLengthInBytes_3Data => new StructuredData(IntegerArrayWithFixedLengthInBytesDataType)
        {
            {
                "Array", new SequenceData(new SequenceDataType(UAOpcBinaryStandardDataTypes.Int32))
                {
                    new PrimitiveData(UAOpcBinaryStandardDataTypes.Int32, 161),
                    new PrimitiveData(UAOpcBinaryStandardDataTypes.Int32, 162),
                    new PrimitiveData(UAOpcBinaryStandardDataTypes.Int32, 163)
                }
            }
        };

        [NotNull]
        static private StructuredData IntegerArrayWithFixedLengthInBytes_4Data => new StructuredData(IntegerArrayWithFixedLengthInBytesDataType)
        {
            {
                "Array", new SequenceData(new SequenceDataType(UAOpcBinaryStandardDataTypes.Int32))
                {
                    new PrimitiveData(UAOpcBinaryStandardDataTypes.Int32, 161),
                    new PrimitiveData(UAOpcBinaryStandardDataTypes.Int32, 162),
                    new PrimitiveData(UAOpcBinaryStandardDataTypes.Int32, 163),
                    new PrimitiveData(UAOpcBinaryStandardDataTypes.Int32, 164)
                }
            }
        };

        [NotNull]
        static private byte[] IntegerArrayWithFixedLengthInBytes_2ExtensionObjectBody => new byte[]
            {161, 0, 0, 0, 162, 0, 0, 0, 0, 0, 0, 0};

        [NotNull]
        static private byte[] IntegerArrayWithFixedLengthInBytes_3ExtensionObjectBody => new byte[]
            {161, 0, 0, 0, 162, 0, 0, 0, 163, 0, 0, 0};

        #endregion



        #region Test Methods

        [TestMethod]
        public void EncodeErrorTest_BinaryEncoderSequenceWithFixedLengthInBytesTooLong() =>
            EncodeErrorTest(null, 
                TypeDictionaryByteArray,
                "IntegerArrayWithFixedLengthInBytes",
                IntegerArrayWithFixedLengthInBytes_4Data,
                UADataTypeModelErrorCodes.OpcBinaryDictionaryEncoderSequenceWithFixedLengthInBytesTooLong);

        [TestMethod]
        public void DecodeTest_IntegerArrayWithFixedLengthInBytes() =>
            DecodeTest(null,
                TypeDictionaryByteArray,
                "IntegerArrayWithFixedLengthInBytes",
                IntegerArrayWithFixedLengthInBytes_3ExtensionObjectBody,
                IntegerArrayWithFixedLengthInBytes_3Data);

        [TestMethod]
        public void EncodeTest_IntegerArrayWithFixedLengthInBytes() =>
            EncodeTest(null, 
                TypeDictionaryByteArray,
                "IntegerArrayWithFixedLengthInBytes",
                IntegerArrayWithFixedLengthInBytes_3Data,
                IntegerArrayWithFixedLengthInBytes_3ExtensionObjectBody);

        [TestMethod]
        public void EncodeTest_IntegerArrayWithFixedLengthInBytes_2() =>
            EncodeTest(null, 
                TypeDictionaryByteArray,
                "IntegerArrayWithFixedLengthInBytes",
                IntegerArrayWithFixedLengthInBytes_2Data,
                IntegerArrayWithFixedLengthInBytes_2ExtensionObjectBody);

        #endregion
    }
}
