﻿using JetBrains.Annotations;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using OpcLabs.BaseLibFactory.OperationModel;
using OpcLabs.EasyOpc.UA.OperationModel;
using OpcLabs.EasyOpcFactory.UA;
using OpcLabs.UnitTestLib;

namespace OpcLabs.EasyOpcTest.UA.OperationModel
{
    public partial class EasyUASubscriptionChangeArgumentsTest
    {
        [TestCategory("BinarySerialization")]
        [TestCategory("OpcUA")]
        [TestMethod]
        public void BinarySerializationTest0()
        {
            Tests.BinarySerializationTest(CreateSerializationTarget0());
        }

        [TestCategory("BinarySerialization")]
        [TestCategory("OpcUA")]
        [TestMethod]
        public void BinarySerializationTest1()
        {
            Tests.BinarySerializationTest(CreateSerializationTarget1());
        }

        [TestCategory("OpcUA")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        public void XmlSerializationTest0()
        {
            Tests.XmlSerializationTest(CreateSerializationTarget0());
        }

        [TestCategory("OpcUA")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        public void XmlSerializationTest1()
        {
            Tests.XmlSerializationTest(CreateSerializationTarget1());
        }

        [NotNull]
        static public EasyUASubscriptionChangeArguments CreateSerializationTarget0()
        {
            return new EasyUASubscriptionChangeArguments();
        }

        [NotNull]
        static public EasyUASubscriptionChangeArguments CreateSerializationTarget1()
        {
            return new EasyUASubscriptionChangeArguments(
                HandleArgumentsInstances.Instance1,
                UAMonitoringParametersInstances.Instance1,
                UASubscriptionParametersInstances.Instance1);
        }
    }
}
